#include "lcd.h"
//------------------------------------------------
uint8_t buf[1]={0};
extern I2C_HandleTypeDef hi2c1;
uint8_t portlcd; //      
char str2[60]={0};
//------------------------------------------------
__STATIC_INLINE void DelayMicro(__IO uint32_t micros)
{
	micros *=(SystemCoreClock / 1000000) / 5;
	while (micros--);
}
//------------------------------------------------
void LCD_WriteByteI2CLCD(uint8_t bt)
{
	buf[0]=bt;
	HAL_I2C_Master_Transmit(&hi2c1,(uint16_t) 0x4E,buf,1,1000);
}
//------------------------------------------------
void sendhalfbyte(uint8_t c)
{
	c<<=4;
	e_set();//  E
	DelayMicro(50);
	LCD_WriteByteI2CLCD(portlcd|c);
	e_reset();//  E
	DelayMicro(50);
}
//------------------------------------------------
void sendbyte(uint8_t c, uint8_t mode)
{
	if(mode==0) rs_reset();
	else rs_set();
	uint8_t hc=0;
	hc=c>>4;
	sendhalfbyte(hc);sendhalfbyte(c);
}
//------------------------------------------------
void LCD_Clear(void)
{
	sendbyte(0x01,0);
	HAL_Delay(2);
}
//------------------------------------------------
void LCD_SendChar(char ch)
{
	sendbyte(ch,1);
}
//------------------------------------------------
void LCD_String(char* st)
{
	uint8_t i=0;
	while(st[i]!=0)
	{
		sendbyte(st[i],1);
		i++;
	}
}
//------------------------------------------------
void LCD_SetPos(uint8_t x, uint8_t y)
{
	switch(y)
	{
		case 0:
			sendbyte(x|0x80,0);
			HAL_Delay(1);
			break;
		case 1:
			sendbyte((0x40+x)|0x80,0);
			HAL_Delay(1);
			break;
		case 2:
			sendbyte((0x14+x)|0x80,0);
			HAL_Delay(1);
			break;
		case 3:
			sendbyte((0x54+x)|0x80,0);
			HAL_Delay(1);
			break;
	}
}
//------------------------------------------------
void LCD_StrBottom(char* st)
{
  uint8_t i=0,j=0,str_cnt=0;
	//       
	for(j=0;j<3;j++)
	{
		LCD_SetPos(0,j);
		for(i=0;i<20;i++)
		{
			sendbyte(str2[j*20+i],1);
		}
	}
	//  
	LCD_SetPos(0,3);
	while((st[str_cnt]!=0)&&(st[str_cnt]!=0x0D)&&(st[str_cnt]!=0x0A))
	{
		sendbyte(st[str_cnt],1);
		str_cnt++;
	}
	// - 
	for(i=str_cnt;i<20;i++)
	{
		sendbyte((uint8_t)' ',1);
	}
	// 2     
	for(i=0;i<2;i++){
		memcpy((void*)(str2+i*20),(void*)(str2+i*20+20),20);
	}
	//     (  )
  memcpy((void*)(str2+40),(void*)st,str_cnt);
  //    
  memset((void*)(str2+40+str_cnt),(uint8_t)' ',20-str_cnt);
}
//------------------------------------------------
void LCD_ini(void)
{
	HAL_Delay(15);
	sendhalfbyte(0x03);
	HAL_Delay(4);
	sendhalfbyte(0x03);
	DelayMicro(100);
	sendhalfbyte(0x03);
	HAL_Delay(1);
	sendhalfbyte(0x02);
	HAL_Delay(1);
	sendbyte(0x28,0);// 4 , 2  (     4 ,  58	
	HAL_Delay(1);
	sendbyte(0x0C,0);//  (D=1),    
	HAL_Delay(1);
	sendbyte(0x01,0);// 
	HAL_Delay(2);
	sendbyte(0x06,0);// 
	HAL_Delay(1);
	setled();//
	setwrite();//
	//    
	memset((void*)str2,(uint8_t)' ',60);
}

